Index: boost/graph/graph_concepts.hpp
===================================================================
RCS file: /cvsroot/boost/boost/boost/graph/graph_concepts.hpp,v
retrieving revision 1.39
diff -u -r1.39 graph_concepts.hpp
--- boost/graph/graph_concepts.hpp	31 Oct 2004 19:55:14 -0000	1.39
+++ boost/graph/graph_concepts.hpp	23 Feb 2005 17:28:20 -0000
@@ -153,7 +153,7 @@
     G g;
   };
 
-// dwa 2003/7/11 -- This clearly shouldn't be neccessary, but if
+// dwa 2003/7/11 -- This clearly shouldn't be necessary, but if
 // you want to use vector_as_graph, it is!  I'm sure the graph
 // library leaves these out all over the place.  Probably a
 // redesign involving specializing a template with a static
@@ -186,7 +186,7 @@
         vertex_list_graph_tag> >();
 
 #ifdef BOOST_VECTOR_AS_GRAPH_GRAPH_ADL_HACK
-      // dwa 2003/7/11 -- This clearly shouldn't be neccessary, but if
+      // dwa 2003/7/11 -- This clearly shouldn't be necessary, but if
       // you want to use vector_as_graph, it is!  I'm sure the graph
       // library leaves these out all over the place.  Probably a
       // redesign involving specializing a template with a static
@@ -199,7 +199,7 @@
     }
     void const_constraints(const G& cg) {
 #ifdef BOOST_VECTOR_AS_GRAPH_GRAPH_ADL_HACK
-      // dwa 2003/7/11 -- This clearly shouldn't be neccessary, but if
+      // dwa 2003/7/11 -- This clearly shouldn't be necessary, but if
       // you want to use vector_as_graph, it is!  I'm sure the graph
       // library leaves these out all over the place.  Probably a
       // redesign involving specializing a template with a static
Index: boost/iterator/detail/config_def.hpp
===================================================================
RCS file: /cvsroot/boost/boost/boost/iterator/detail/config_def.hpp,v
retrieving revision 1.9
diff -u -r1.9 config_def.hpp
--- boost/iterator/detail/config_def.hpp	3 Dec 2004 09:55:30 -0000	1.9
+++ boost/iterator/detail/config_def.hpp	23 Feb 2005 17:28:20 -0000
@@ -40,7 +40,7 @@
 // end up using a proxy for operator[] when we otherwise shouldn't.
 // Using reference constness gives it an extra hint that it can
 // return the value_type from operator[] directly, but is not
-// strictly neccessary.  Not sure how best to resolve this one.
+// strictly necessary.  Not sure how best to resolve this one.
 
 # define BOOST_ITERATOR_REF_CONSTNESS_KILLS_WRITABILITY 1
 
Index: boost/operators.hpp
===================================================================
RCS file: /cvsroot/boost/boost/boost/operators.hpp,v
retrieving revision 1.22
diff -u -r1.22 operators.hpp
--- boost/operators.hpp	30 Jul 2004 04:46:55 -0000	1.22
+++ boost/operators.hpp	23 Feb 2005 17:28:21 -0000
@@ -674,7 +674,7 @@
 // Here's where we put it all together, defining the xxxx forms of the templates
 // in namespace boost. We also define specializations of is_chained_base<> for
 // the xxxx, xxxx1, and xxxx2 templates, importing them into boost:: as
-// neccessary.
+// necessary.
 //
 #ifndef BOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION
 
@@ -699,7 +699,7 @@
 
 } // namespace boost
 
-// Import a 4-type-argument operator template into boost (if neccessary) and
+// Import a 4-type-argument operator template into boost (if necessary) and
 // provide a specialization of 'is_chained_base<>' for it.
 # define BOOST_OPERATOR_TEMPLATE4(template_name4)                     \
   BOOST_IMPORT_TEMPLATE4(template_name4)                              \
@@ -708,7 +708,7 @@
     typedef ::boost::detail::true_t value;                            \
   };
 
-// Import a 3-type-argument operator template into boost (if neccessary) and
+// Import a 3-type-argument operator template into boost (if necessary) and
 // provide a specialization of 'is_chained_base<>' for it.
 # define BOOST_OPERATOR_TEMPLATE3(template_name3)                     \
   BOOST_IMPORT_TEMPLATE3(template_name3)                              \
@@ -717,7 +717,7 @@
     typedef ::boost::detail::true_t value;                            \
   };
 
-// Import a 2-type-argument operator template into boost (if neccessary) and
+// Import a 2-type-argument operator template into boost (if necessary) and
 // provide a specialization of 'is_chained_base<>' for it.
 # define BOOST_OPERATOR_TEMPLATE2(template_name2)                  \
   BOOST_IMPORT_TEMPLATE2(template_name2)                           \
@@ -726,7 +726,7 @@
     typedef ::boost::detail::true_t value;                         \
   };
 
-// Import a 1-type-argument operator template into boost (if neccessary) and
+// Import a 1-type-argument operator template into boost (if necessary) and
 // provide a specialization of 'is_chained_base<>' for it.
 # define BOOST_OPERATOR_TEMPLATE1(template_name1)                  \
   BOOST_IMPORT_TEMPLATE1(template_name1)                           \
Index: boost/python/converter/registry.hpp
===================================================================
RCS file: /cvsroot/boost/boost/boost/python/converter/registry.hpp,v
retrieving revision 1.16
diff -u -r1.16 registry.hpp
--- boost/python/converter/registry.hpp	26 Jul 2004 00:32:06 -0000	1.16
+++ boost/python/converter/registry.hpp	23 Feb 2005 17:28:21 -0000
@@ -17,7 +17,7 @@
 // This namespace acts as a sort of singleton
 namespace registry
 {
-  // Get the registration corresponding to the type, creating it if neccessary
+  // Get the registration corresponding to the type, creating it if necessary
   BOOST_PYTHON_DECL registration const& lookup(type_info);
 
   // Return a pointer to the corresponding registration, if one exists
Index: boost/python/object/iterator.hpp
===================================================================
RCS file: /cvsroot/boost/boost/boost/python/object/iterator.hpp,v
retrieving revision 1.19
diff -u -r1.19 iterator.hpp
--- boost/python/object/iterator.hpp	20 Aug 2004 11:09:17 -0000	1.19
+++ boost/python/object/iterator.hpp	23 Feb 2005 17:28:21 -0000
@@ -109,7 +109,7 @@
 namespace detail
 {
   // Get a Python class which contains the given iterator and
-  // policies, creating it if neccessary. Requires: NextPolicies is
+  // policies, creating it if necessary. Requires: NextPolicies is
   // default-constructible.
   template <class Iterator, class NextPolicies>
   object demand_iterator_class(char const* name, Iterator* = 0, NextPolicies const& policies = NextPolicies())
Index: libs/filesystem/doc/faq.htm
===================================================================
RCS file: /cvsroot/boost/boost/libs/filesystem/doc/faq.htm,v
retrieving revision 1.13
diff -u -r1.13 faq.htm
--- libs/filesystem/doc/faq.htm	5 Oct 2004 15:45:20 -0000	1.13
+++ libs/filesystem/doc/faq.htm	23 Feb 2005 17:28:21 -0000
@@ -31,7 +31,7 @@
 <p><b>Why do some function names have a &quot;native_&quot; prefix?</b></p>
 <p>To alert users that the results are inherently non-portable. The names are 
 deliberately ugly to discourage use except where really necessary.</p>
-<p><b>Why not support a  concept of specific kinds of file systems, such as posix_file_system or windows_file_system.</b></p>
+<p><b>Why not support a concept of specific kinds of file systems, such as posix_file_system or windows_file_system?</b></p>
 <p>Portability is one of the one or two most important requirements for the 
 library.&nbsp;Gaining some advantage by using features specific to particular 
 operating systems is not a requirement. There doesn't appear to be much need for 
@@ -192,4 +192,4 @@
 <p> Use, modification, and distribution are subject to the Boost Software 
 License, Version 1.0. (See accompanying file <a href="../../../LICENSE_1_0.txt">
 LICENSE_1_0.txt</a> or copy at <a href="http://www.boost.org/LICENSE_1_0.txt">
-www.boost.org/LICENSE_1_0.txt</a>)</p>
\ No newline at end of file
+www.boost.org/LICENSE_1_0.txt</a>)</p>
Index: libs/iterator/doc/pointee.rst
===================================================================
RCS file: /cvsroot/boost/boost/libs/iterator/doc/pointee.rst,v
retrieving revision 1.3
diff -u -r1.3 pointee.rst
--- libs/iterator/doc/pointee.rst	1 Nov 2004 21:23:47 -0000	1.3
+++ libs/iterator/doc/pointee.rst	23 Feb 2005 17:28:21 -0000
@@ -42,7 +42,7 @@
 ``Dereferenceable``\ s, but it makes very good guesses (it works
 for all pointers, standard and boost smart pointers, and
 iterators), and when it guesses wrongly, it can be specialized as
-neccessary::
+necessary::
 
   namespace boost
   {
Index: libs/iterator/doc/interoperability-revisited.rst
===================================================================
RCS file: /cvsroot/boost/boost/libs/iterator/doc/interoperability-revisited.rst,v
retrieving revision 1.1
diff -u -r1.1 interoperability-revisited.rst
--- libs/iterator/doc/interoperability-revisited.rst	6 Jan 2004 19:37:17 -0000	1.1
+++ libs/iterator/doc/interoperability-revisited.rst	23 Feb 2005 17:28:21 -0000
@@ -67,7 +67,7 @@
 c == m; // ok, dispatched to Constant::equal_to
 m == c; // !! error, dispatched to Mutable::equal_to
 
-Instead the following "slightly" more complicated implementation is neccessary
+Instead the following "slightly" more complicated implementation is necessary
 
 struct Mutable : Facade<Mutable>
 {
@@ -87,7 +87,7 @@
 
 Beside the fact that the code is significantly more complex to understand and to teach there is
 a major design problem lurking here. Note that in both types equal_to is a function template with 
-an unconstrained argument T. This is neccessary so that further types can be made interoperable with
+an unconstrained argument T. This is necessary so that further types can be made interoperable with
 Mutable or Constant. Would Mutable be defined as  
 
 struct Mutable : Facade<Mutable>
@@ -229,4 +229,4 @@
 a) Less burden for the user
 
 b) The definition (standardese) of specialized adpters might be easier 
-   (This has to be proved yet)
\ No newline at end of file
+   (This has to be proved yet)
Index: libs/iterator/doc/pointee.html
===================================================================
RCS file: /cvsroot/boost/boost/libs/iterator/doc/pointee.html,v
retrieving revision 1.6
diff -u -r1.6 pointee.html
--- libs/iterator/doc/pointee.html	2 Nov 2004 14:31:13 -0000	1.6
+++ libs/iterator/doc/pointee.html	23 Feb 2005 17:28:21 -0000
@@ -63,7 +63,7 @@
 <tt class="literal"><span class="pre">Dereferenceable</span></tt>s, but it makes very good guesses (it works
 for all pointers, standard and boost smart pointers, and
 iterators), and when it guesses wrongly, it can be specialized as
-neccessary:</p>
+necessary:</p>
 <pre class="literal-block">
 namespace boost
 {
Index: libs/mpl/doc/tutorial/details.html
===================================================================
RCS file: /cvsroot/boost/boost/libs/mpl/doc/tutorial/details.html,v
retrieving revision 1.2
diff -u -r1.2 details.html
--- libs/mpl/doc/tutorial/details.html	28 Nov 2004 03:35:11 -0000	1.2
+++ libs/mpl/doc/tutorial/details.html	23 Feb 2005 17:28:21 -0000
@@ -105,8 +105,8 @@
 to in lieu of using <tt class="literal"><span class="pre">lambda</span></tt> and invoking the result &quot;manually.&quot;</dd>
 <dt>Lazy evaluation.</dt>
 <dd>A strategy of delaying evaluation until a result is
-required, thereby avoiding any unneccessary computation and any
-associated unneccessary errors.  Metafunctions are only invoked
+required, thereby avoiding any unnecessary computation and any
+associated unnecessary errors.  Metafunctions are only invoked
 when we access their nested <tt class="literal"><span class="pre">::type</span></tt>s, so we can supply all
 of their arguments without performing any computation and
 delay evaluation to the last possible moment.</dd>
Index: libs/python/doc/PyConDC_2003/bpl_mods.txt
===================================================================
RCS file: /cvsroot/boost/boost/libs/python/doc/PyConDC_2003/bpl_mods.txt,v
retrieving revision 1.1
diff -u -r1.1 bpl_mods.txt
--- libs/python/doc/PyConDC_2003/bpl_mods.txt	7 Feb 2003 01:07:39 -0000	1.1
+++ libs/python/doc/PyConDC_2003/bpl_mods.txt	23 Feb 2005 17:28:21 -0000
@@ -273,7 +273,7 @@
 ==================
 
 This section outlines some of the library's major features.  Except as
-neccessary to avoid confusion, details of library implementation are
+necessary to avoid confusion, details of library implementation are
 omitted.
 
 -------------------------------------------
@@ -537,7 +537,7 @@
    called with an object wrapping a ``Derived`` instance.  Wrapped
    member functions of class ``T`` are treated as though they have an
    implicit first argument of ``T&``, so these conversions are
-   neccessary to allow the base class methods to be called for derived
+   necessary to allow the base class methods to be called for derived
    objects.
 
 Of course it's possible to derive new Python classes from wrapped C++
@@ -650,7 +650,7 @@
   called on an object of type ``BaseWrap``, since it overrides ``f``.
 
 Admittedly, this formula is tedious to repeat, especially on a project
-with many polymorphic classes; that it is neccessary reflects
+with many polymorphic classes; that it is necessary reflects
 limitations in C++'s compile-time reflection capabilities.  Several
 efforts are underway to write front-ends for Boost.Python which can
 generate these dispatchers (and other wrapping code) automatically.
Index: libs/python/doc/v2/errors.html
===================================================================
RCS file: /cvsroot/boost/boost/libs/python/doc/v2/errors.html,v
retrieving revision 1.11
diff -u -r1.11 errors.html
--- libs/python/doc/v2/errors.html	28 Nov 2004 03:54:58 -0000	1.11
+++ libs/python/doc/v2/errors.html	23 Feb 2005 17:28:21 -0000
@@ -126,7 +126,7 @@
 
       <dt><b>Rationale:</b> At inter-language boundaries it is important to
       ensure that no C++ exceptions escape, since the calling language
-      usually doesn't have the equipment neccessary to properly unwind the
+      usually doesn't have the equipment necessary to properly unwind the
       stack. Use <code>handle_exception</code> to manage exception
       translation whenever your C++ code is called directly from the Python
       API. This is done for you automatically by the usual function wrapping
Index: libs/python/doc/v2/type_id.html
===================================================================
RCS file: /cvsroot/boost/boost/libs/python/doc/v2/type_id.html,v
retrieving revision 1.4
diff -u -r1.4 type_id.html
--- libs/python/doc/v2/type_id.html	2 Nov 2004 19:46:46 -0000	1.4
+++ libs/python/doc/v2/type_id.html	23 Feb 2005 17:28:21 -0000
@@ -121,7 +121,7 @@
       <dt><b>Effects:</b> constructs a <code>type_info</code> object which
       identifies the same type as its argument.</dt>
 
-      <dt><b>Rationale:</b> Since it is occasionally neccessary to make an
+      <dt><b>Rationale:</b> Since it is occasionally necessary to make an
       array of <code>type_info</code> objects a benign default argument is
       supplied. <span class="c3"><b>Note:</b></span> this constructor does
       <i>not</i> correct for non-conformance of compiler
Index: libs/python/doc/new-conversions.html
===================================================================
RCS file: /cvsroot/boost/boost/libs/python/doc/new-conversions.html,v
retrieving revision 1.4
diff -u -r1.4 new-conversions.html
--- libs/python/doc/new-conversions.html	5 Oct 2004 15:45:43 -0000	1.4
+++ libs/python/doc/new-conversions.html	23 Feb 2005 17:28:22 -0000
@@ -260,7 +260,7 @@
 <ol>
 <li> Treat built-in types specially: when unwrapping a value or
    constant reference to one of these, use a value for the target
-   type. It will bind to a const reference if neccessary, and more
+   type. It will bind to a const reference if necessary, and more
    importantly, avoids having to dynamically allocate room for
    an lvalue of types which can be cheaply copied.
 <li>
Index: libs/python/src/object/inheritance.cpp
===================================================================
RCS file: /cvsroot/boost/boost/libs/python/src/object/inheritance.cpp,v
retrieving revision 1.13
diff -u -r1.13 inheritance.cpp
--- libs/python/src/object/inheritance.cpp	26 Jul 2004 00:32:11 -0000	1.13
+++ libs/python/src/object/inheritance.cpp	23 Feb 2005 17:28:22 -0000
@@ -203,7 +203,7 @@
           return &*p;
   }
   
-  // Get the entry for a type, inserting if neccessary
+  // Get the entry for a type, inserting if necessary
   inline type_index_t::iterator demand_type(class_id type)
   {
       type_index_t::iterator p = type_position(type);
@@ -218,7 +218,7 @@
       return type_index().insert(p, boost::make_tuple(type, v, dynamic_id_function(0)));
   }
 
-  // Map a two types to a vertex in the graph, inserting if neccessary
+  // Map a two types to a vertex in the graph, inserting if necessary
   typedef std::pair<type_index_t::iterator, type_index_t::iterator>
         type_index_iterator_pair;
   
Index: libs/utility/numeric_traits_test.cpp
===================================================================
RCS file: /cvsroot/boost/boost/libs/utility/numeric_traits_test.cpp,v
retrieving revision 1.11
diff -u -r1.11 numeric_traits_test.cpp
--- libs/utility/numeric_traits_test.cpp	4 Sep 2004 10:34:49 -0000	1.11
+++ libs/utility/numeric_traits_test.cpp	23 Feb 2005 17:28:22 -0000
@@ -57,7 +57,7 @@
     struct traits
     {
      private:
-        // indirection through complement_traits_aux neccessary to keep MSVC happy
+        // indirection through complement_traits_aux necessary to keep MSVC happy
         typedef complement_traits_aux<Number, size - 1> prev;
      public:
         BOOST_STATIC_CONSTANT(Number, max =
Index: more/mailing_lists.htm
===================================================================
RCS file: /cvsroot/boost/boost/more/mailing_lists.htm,v
retrieving revision 1.36
diff -u -r1.36 mailing_lists.htm
--- more/mailing_lists.htm	4 Jan 2005 19:53:14 -0000	1.36
+++ more/mailing_lists.htm	23 Feb 2005 17:28:22 -0000
@@ -102,7 +102,9 @@
     watching the Boost library development process.&nbsp; Virtually all Boost
     decisions, major or minor, technical or otherwise, are reached via public
     discussion on this mailing list.&nbsp; It is where the formal reviews of
-    proposed libraries take place. Subscribe or unsubscribe at <a href="http://lists.boost.org/mailman/listinfo.cgi/boost"    >http://lists.boost.org/mailman/listinfo.cgi/boost</a></p>
+    proposed libraries take place. Subscribe or unsubscribe at <a
+    href="http://lists.boost.org/mailman/listinfo.cgi/boost"
+    >http://lists.boost.org/mailman/listinfo.cgi/boost</a>.</p>
 
     <p>When we talk about the "members of Boost", we are talking about those
     signed up for this main mailing list.</p>
Index: more/generic_programming.html
===================================================================
RCS file: /cvsroot/boost/boost/more/generic_programming.html,v
retrieving revision 1.24
diff -u -r1.24 generic_programming.html
--- more/generic_programming.html	28 Nov 2004 04:34:09 -0000	1.24
+++ more/generic_programming.html	23 Feb 2005 17:28:22 -0000
@@ -75,7 +75,7 @@
     not in an array? Perhaps it is in a linked list. Can we generalize the
     notion of copy to any sequence of elements? Looking at the body of
     <tt>memcpy()</tt>, the function's <b><i>minimal requirements</i></b> are
-    that it needs to to <i>traverse</i> through the sequence using some sort
+    that it needs to <i>traverse</i> through the sequence using some sort
     of pointer, <i>access</i> elements pointed to, <i>write</i> the elements
     to the destination, and <i>compare</i> pointers to know when to stop. The
     C++ standard library groups requirements such as these into
Index: more/getting_started.html
===================================================================
RCS file: /cvsroot/boost/boost/more/getting_started.html,v
retrieving revision 1.23
diff -u -r1.23 getting_started.html
--- more/getting_started.html	30 Dec 2004 00:53:20 -0000	1.23
+++ more/getting_started.html	23 Feb 2005 17:28:22 -0000
@@ -170,7 +170,7 @@
                are using a Boost distribution is to <strong><a href="http://sourceforge.net/project/showfiles.php?group_id=7586&amp;package_id=72941">
                      download a prebuilt executable</a></strong> from SourceForge. If a 
                prebuilt executable is not provided for your platform or you are using Boost's 
-               sources in an unreleased state, it may be neccessary to <A href="../tools/build/jam_src/index.html#building_bjam">
+               sources in an unreleased state, it may be necessary to <A href="../tools/build/jam_src/index.html#building_bjam">
                   build <tt>bjam</tt> from sources</A> included in the Boost source tree. To 
                install Boost.Jam, copy the <tt>bjam</tt> executable to a location accessible 
                in your <tt>PATH</tt>.</td>
Index: tools/build/v1/python.jam
===================================================================
RCS file: /cvsroot/boost/boost/tools/build/v1/python.jam,v
retrieving revision 1.82
diff -u -r1.82 python.jam
--- tools/build/v1/python.jam	19 Oct 2004 12:13:08 -0000	1.82
+++ tools/build/v1/python.jam	23 Feb 2005 17:28:23 -0000
@@ -571,11 +571,12 @@
             ECHO "otherwise set:" ;
             ECHO ;
             ECHO "    PYTHON_LIB_PATH       - path to Python library object; currently" ;
-            ECHO "                          \""$(PYTHON_LIB_PATH:J=" ")\" ;
+            ECHO "                            \""$(PYTHON_LIB_PATH:J=" ")\" ;
             
             if ! $(NT)
             {
-                ECHO "    PYTHON_INCLUDES    - path to Python #include directories; currently" \"$(PYTHON_INCLUDES:J=" ")\" ;
+                ECHO "    PYTHON_INCLUDES       - path to Python #include directories; currently" ;
+                ECHO "                            \""$(PYTHON_INCLUDES:J=" ")\" ;
             }
             else if [ intersection $(TOOLS) : $(gcc-compilers) ]
             {
Index: tools/build/v1/boost-base.jam
===================================================================
RCS file: /cvsroot/boost/boost/tools/build/v1/boost-base.jam,v
retrieving revision 1.145
diff -u -r1.145 boost-base.jam
--- tools/build/v1/boost-base.jam	2 Feb 2005 19:58:01 -0000	1.145
+++ tools/build/v1/boost-base.jam	23 Feb 2005 17:28:23 -0000
@@ -488,7 +488,7 @@
 # normalize-properties properties
 #
 # Normalizes a set of (possibly qualified) properties by prepending <*> as many
-# times as neccessary to ensure that each property has at least 3 gristed elements.
+# times as necessary to ensure that each property has at least 3 gristed elements.
 rule normalize-properties
 {
     local property ;
@@ -710,7 +710,7 @@
 # include-tools toolset
 #
 # Unconditionally process the specification file for the given toolset. It is
-# neccessary to do this for each target built with that toolset, since the
+# necessary to do this for each target built with that toolset, since the
 # toolset will invoke the flags rule to set global variables based on the build
 # properties of the target.
 rule include-tools 
@@ -757,7 +757,7 @@
 # relevant-features toolset
 #
 # Returns the set of unique features relevant to the given toolset; includes the
-# toolset description file as a side-effect if neccessary.
+# toolset description file as a side-effect if necessary.
 rule relevant-features # name
 {
     if ! $(gRELEVANT_FEATURES($(<)))
@@ -797,7 +797,7 @@
         # Because properties in a variant declaration are only qualified with
         # toolset and not variant, we specify the toolset where
         # select-properties expects a variant name. The first toolset parameter
-        # is neccessary to get the relevant-features correctly set. We supply
+        # is necessary to get the relevant-features correctly set. We supply
         # the variant name as the target name, so that error messages will look
         # coherent.
         local name-properties
@@ -919,7 +919,7 @@
 }
 
 # For path properties, add a relative path prefix to the value as
-# neccessary to locate the path relative to the given subproject
+# necessary to locate the path relative to the given subproject
 # directory.
 rule fixup-path-properties ( properties * : subproject-directory ? )
 {
Index: tools/build/v1/gcc-tools.jam
===================================================================
RCS file: /cvsroot/boost/boost/tools/build/v1/gcc-tools.jam,v
retrieving revision 1.97
diff -u -r1.97 gcc-tools.jam
--- tools/build/v1/gcc-tools.jam	2 Feb 2005 01:04:46 -0000	1.97
+++ tools/build/v1/gcc-tools.jam	23 Feb 2005 17:28:23 -0000
@@ -418,7 +418,7 @@
 
         # This will appear before the import library name when building a DLL, but
         # will be "multiplied away" otherwise. The --exclude-symbols directive
-        # proved to be neccessary with some versions of Cygwin.
+        # proved to be necessary with some versions of Cygwin.
         DLL_LINK_FLAGS on $(<) += "-Wl,--exclude-symbols,_bss_end__:_bss_start__:_data_end__:_data_start__" ;
 
         # set the link command to generate an import library
Index: tools/build/v1/sunpro-tools.html
===================================================================
RCS file: /cvsroot/boost/boost/tools/build/v1/sunpro-tools.html,v
retrieving revision 1.5
diff -u -r1.5 sunpro-tools.html
--- tools/build/v1/sunpro-tools.html	5 Oct 2004 15:19:13 -0000	1.5
+++ tools/build/v1/sunpro-tools.html	23 Feb 2005 17:28:24 -0000
@@ -34,7 +34,7 @@
   "http://wwws.sun.com/software/sundev/suncc/index.html">Sun ONE Studio</a>
   compiler. This compiler has been known under several trade names including
   Sun WorkShop and Forte Developer. For convenience, this document will refer
-  to numbered releases of the compiler when differention is neccessary; this
+  to numbered releases of the compiler when differention is necessary; this
   release number can be obtained by running <code>CC &#8209;V</code> at the
   command line.</p>
 
Index: tools/build/v2/doc/src/advanced.xml
===================================================================
RCS file: /cvsroot/boost/boost/tools/build/v2/doc/src/advanced.xml,v
retrieving revision 1.24
diff -u -r1.24 advanced.xml
--- tools/build/v2/doc/src/advanced.xml	24 Jan 2005 10:08:06 -0000	1.24
+++ tools/build/v2/doc/src/advanced.xml	23 Feb 2005 17:28:24 -0000
@@ -155,7 +155,7 @@
 <programlisting>
 using gcc : : g++-3.2 ;
 </programlisting>
-Otherwise, it might be neccessary to supply the complete path to the
+Otherwise, it might be necessary to supply the complete path to the
 compiler executable:
 <programlisting>
 using msvc : : Z:/Programs/Microsoft Visual Studio/vc98/bin/cl ;
Index: tools/build/v2/doc/src/extending.xml
===================================================================
RCS file: /cvsroot/boost/boost/tools/build/v2/doc/src/extending.xml,v
retrieving revision 1.19
diff -u -r1.19 extending.xml
--- tools/build/v2/doc/src/extending.xml	2 Feb 2005 14:41:30 -0000	1.19
+++ tools/build/v2/doc/src/extending.xml	23 Feb 2005 17:28:25 -0000
@@ -840,7 +840,7 @@
             version. This can lead to building twice with the same version.
             <!-- That would not be so terrible, and is much less harmful
                  than this restriction, IMO.  It makes site-config
-                 harder to maintain than neccessary. -->
+                 harder to maintain than necessary. -->
             </para></listitem>
 
         <listitem><para>If possible, <code>init</code> must be callable
Index: tools/build/v2/doc/src/install.xml
===================================================================
RCS file: /cvsroot/boost/boost/tools/build/v2/doc/src/install.xml,v
retrieving revision 1.7
diff -u -r1.7 install.xml
--- tools/build/v2/doc/src/install.xml	28 Dec 2004 14:46:12 -0000	1.7
+++ tools/build/v2/doc/src/install.xml	23 Feb 2005 17:28:25 -0000
@@ -47,7 +47,7 @@
           a prebuilt executable</ulink></emphasis> from SourceForge.
           If a prebuilt executable is not provided for your platform
           or you are using Boost's sources in an unreleased state, it
-          may be neccessary to <ulink
+          may be necessary to <ulink
           url= "../../tools/build/jam_src/index.html#building_bjam">build <command>bjam</command>
           from sources</ulink> included in the Boost source tree.
         </simpara>
@@ -80,7 +80,7 @@
           system.  Open the
           <filename>user-config.jam</filename> file in the Boost.Build
           root directory and follow the instructions there to describe
-          your toolsets and libraries, and, if neccessary, where they
+          your toolsets and libraries, and, if necessary, where they
           are located.
         </simpara>
       </listitem>
Index: tools/build/v2/doc/src/reference.xml
===================================================================
RCS file: /cvsroot/boost/boost/tools/build/v2/doc/src/reference.xml,v
retrieving revision 1.9
diff -u -r1.9 reference.xml
--- tools/build/v2/doc/src/reference.xml	9 Feb 2005 16:39:43 -0000	1.9
+++ tools/build/v2/doc/src/reference.xml	23 Feb 2005 17:28:25 -0000
@@ -645,7 +645,7 @@
               feature. When generating targets from a set of build
               properties, composite features are recursively expanded and
               <emphasis>added</emphasis> to the build property set, so rules can find
-              them if neccessary. Non-composite non-free features override
+              them if necessary. Non-composite non-free features override
               components of composite features in a build property set.</para>
           </listitem>
 
Index: tools/build/v2/doc/src/tutorial.xml
===================================================================
RCS file: /cvsroot/boost/boost/tools/build/v2/doc/src/tutorial.xml,v
retrieving revision 1.14
diff -u -r1.14 tutorial.xml
--- tools/build/v2/doc/src/tutorial.xml	26 Jan 2005 08:40:28 -0000	1.14
+++ tools/build/v2/doc/src/tutorial.xml	23 Feb 2005 17:28:25 -0000
@@ -42,7 +42,7 @@
 
       Note that debug and release variants are created in different
       directories, so you can switch between variants or even build
-      multiple variants at once, without any unneccessary
+      multiple variants at once, without any unnecessary
       recompilation. Let's extend the example by adding another line
       to our project's <filename>Jamroot</filename>:
 
@@ -369,7 +369,7 @@
     <para>Let's improve this project further.
       The library
       probably has some headers that must be used when compiling
-      <filename>app.cpp</filename>. We could manually add the neccessary
+      <filename>app.cpp</filename>. We could manually add the necessary
       <code>#include</code> paths to <filename>app</filename>'s
       requirements as values of the
       <varname>&lt;include&gt;</varname> feature, but then this work will 
Index: tools/build/v2/test/recursive.jam
===================================================================
RCS file: /cvsroot/boost/boost/tools/build/v2/test/recursive.jam,v
retrieving revision 1.6
diff -u -r1.6 recursive.jam
--- tools/build/v2/test/recursive.jam	7 Apr 2002 00:22:45 -0000	1.6
+++ tools/build/v2/test/recursive.jam	23 Feb 2005 17:28:25 -0000
@@ -7,7 +7,7 @@
 ##############################################################
 # Rules and actions that test Jam by invoking it recursively #
 #                                                            #
-# This is neccessary for testing anything that requires Jam  #
+# This is necessary for testing anything that requires Jam   #
 # to execute build actions whose results must be checked,    #
 # and anything which exits Jam with a failure code (e.g. a   #
 # failed assertion).                                         #
Index: tools/build/v2/generators_prototype.py
===================================================================
RCS file: /cvsroot/boost/boost/tools/build/v2/generators_prototype.py,v
retrieving revision 1.5
diff -u -r1.5 generators_prototype.py
--- tools/build/v2/generators_prototype.py	6 Jun 2003 16:19:57 -0000	1.5
+++ tools/build/v2/generators_prototype.py	23 Feb 2005 17:28:25 -0000
@@ -558,7 +558,7 @@
                 # the given parent set
                 siblings = ()
                 for t,n in generator.targets_.items():
-                    # Unary generators run as many times as neccessary
+                    # Unary generators run as many times as necessary
                     # to consume the group
                     if (generator.unary):
                         n *= g.size
Index: Jamfile
===================================================================
RCS file: /cvsroot/boost/boost/Jamfile,v
retrieving revision 1.17
diff -u -r1.17 Jamfile
--- Jamfile	12 Aug 2004 06:13:36 -0000	1.17
+++ Jamfile	23 Feb 2005 17:28:26 -0000
@@ -9,7 +9,8 @@
     bjam [options] [install|stage]
 
     * install               Installs to the configured location(s).
-    * stage                 Stages the build products only to common stage location.
+    * stage                 Stages the build products only to common stage
+                            location.
 
 Options:
     --help                  This message.
@@ -49,18 +50,19 @@
                             Default; PREFIX/include
                             
     --builddir=DIR          Build in this location instead of building
-                            within the distribution tree. Recomended!
+                            within the distribution tree. Recommended!
                             
     --stagedir=DIR          When staging only, stage to the location.
                             Default; ./stage
 
 Features:
     --with-<library>        Build, stage, or install the specified <library>
-                            If used, teh default becomes to only build
+                            If used, the default becomes to only build
                             indicated libraries.
                             
     --without-<library>     Do not build, stage, or install the specified
-                            <library>. By default all libraries attempt to build.
+                            <library>. By default all libraries attempt to
+                            build.
                             
     --with-python-root[=PYTHON_ROOT]
                             Build Boost.Python libraries with the Python