Index: doc/macro_reference.qbk
===================================================================
--- doc/macro_reference.qbk	(revision 65491)
+++ doc/macro_reference.qbk	(working copy)
@@ -144,6 +144,9 @@
 this symbol in library code; always include `<boost/limits.hpp>`, which
 guarantees to provide `std::numeric_limits`.
 ]]
+[[`BOOST_NO_LIMITS_LOWEST`][Standard library][
+Static function `numeric_limits<T>::lowest()` is not available for use.
+]]
 [[`BOOST_NO_LIMITS_COMPILE_TIME_CONSTANTS`][Standard library][
 Constants such as `numeric_limits<T>::is_signed` are not available for use
 at compile-time.
Index: test/all/Jamfile.v2
===================================================================
--- test/all/Jamfile.v2	(revision 65491)
+++ test/all/Jamfile.v2	(working copy)
@@ -1,7 +1,7 @@
 #
 # Regression test Jamfile for boost configuration setup.
 # *** DO NOT EDIT THIS FILE BY HAND ***
-# This file was automatically generated on Tue Aug 17 09:59:01 2010
+# This file was automatically generated on Wed Sep 22 15:59:39 2010
 #  by libs/config/tools/generate.cpp
 # Copyright John Maddock.
 # Use, modification and distribution are subject to the 
@@ -367,6 +367,9 @@
 test-suite "BOOST_NO_LIMITS_COMPILE_TIME_CONSTANTS" : 
 [ run ../no_limits_const_exp_pass.cpp ]
 [ compile-fail ../no_limits_const_exp_fail.cpp ] ;
+test-suite "BOOST_NO_LIMITS_LOWEST" : 
+[ run ../no_limits_lowest_pass.cpp ]
+[ compile-fail ../no_limits_lowest_fail.cpp ] ;
 test-suite "BOOST_NO_LONG_LONG_NUMERIC_LIMITS" : 
 [ run ../no_ll_limits_pass.cpp ]
 [ compile-fail ../no_ll_limits_fail.cpp ] ;
Index: test/boost_no_limits_lowest.ipp
===================================================================
--- test/boost_no_limits_lowest.ipp	(revision 0)
+++ test/boost_no_limits_lowest.ipp	(revision 0)
@@ -0,0 +1,31 @@
+//  (C) Copyright Vicente J. Botet Escriba 2010. 
+//  Use, modification and distribution are subject to the 
+//  Boost Software License, Version 1.0. (See accompanying file 
+//  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
+
+//  See http://www.boost.org/libs/config for most recent version.
+
+//  MACRO:         BOOST_NO_LIMITS_LOWEST
+//  TITLE:         static function lowest() in numeric_limits class <limits>
+//  DESCRIPTION:   static function numeric_limits<T>::lowest() are not available for use.
+
+#include <limits>
+
+namespace boost_no_limits_lowest{
+
+int f()
+{
+    // this is never called, it just has to compile:
+    return std::numeric_limits<int>::lowest();
+}
+
+int test()
+{
+   return 0;
+}
+
+}
+
+
+
+

Property changes on: test\boost_no_limits_lowest.ipp
___________________________________________________________________
Added: svn:mime-type
   + text/plain
Added: svn:eol-style
   + native

Index: test/config_info.cpp
===================================================================
--- test/config_info.cpp	(revision 65491)
+++ test/config_info.cpp	(working copy)
@@ -1017,6 +1017,7 @@
    PRINT_MACRO(BOOST_NO_LAMBDAS);
    PRINT_MACRO(BOOST_NO_LIMITS);
    PRINT_MACRO(BOOST_NO_LIMITS_COMPILE_TIME_CONSTANTS);
+   PRINT_MACRO(BOOST_NO_LIMITS_LOWEST);
    PRINT_MACRO(BOOST_NO_LONG_LONG);
    PRINT_MACRO(BOOST_NO_LONG_LONG_NUMERIC_LIMITS);
    PRINT_MACRO(BOOST_NO_MEMBER_FUNCTION_SPECIALIZATIONS);
@@ -1086,6 +1087,7 @@
 
 
 
+
    // END GENERATED BLOCK
 
    PRINT_MACRO(BOOST_INTEL);
Index: test/config_test.cpp
===================================================================
--- test/config_test.cpp	(revision 65491)
+++ test/config_test.cpp	(working copy)
@@ -1,4 +1,4 @@
-//  This file was automatically generated on Tue Aug 17 09:59:01 2010
+//  This file was automatically generated on Wed Sep 22 15:59:39 2010
 //  by libs/config/tools/generate.cpp
 //  Copyright John Maddock 2002-4.
 //  Use, modification and distribution are subject to the 
@@ -342,6 +342,11 @@
 #else
 namespace boost_no_limits_compile_time_constants = empty_boost;
 #endif
+#ifndef BOOST_NO_LIMITS_LOWEST
+#include "boost_no_limits_lowest.ipp"
+#else
+namespace boost_no_limits_lowest = empty_boost;
+#endif
 #ifndef BOOST_NO_LONG_LONG_NUMERIC_LIMITS
 #include "boost_no_ll_limits.ipp"
 #else
@@ -1436,6 +1441,11 @@
       std::cerr << "Failed test for BOOST_NO_LIMITS_COMPILE_TIME_CONSTANTS at: " << __FILE__ << ":" << __LINE__ << std::endl;
       ++error_count;
    }
+   if(0 != boost_no_limits_lowest::test())
+   {
+      std::cerr << "Failed test for BOOST_NO_LIMITS_LOWEST at: " << __FILE__ << ":" << __LINE__ << std::endl;
+      ++error_count;
+   }
    if(0 != boost_no_long_long_numeric_limits::test())
    {
       std::cerr << "Failed test for BOOST_NO_LONG_LONG_NUMERIC_LIMITS at: " << __FILE__ << ":" << __LINE__ << std::endl;