>From 31a16adc885ba5d472e43849496ded1554fbe17c Mon Sep 17 00:00:00 2001
From: David Wagner <david.wagner@intel.com>
Date: Mon, 27 Oct 2014 10:48:42 +0100
Subject: [PATCH] Android makefiles for Asio, its tests and their dependencies

Signed-off-by: David Wagner <david.wagner@intel.com>
---
 Android.mk                   |    1 +
 android/Android.mk           |   54 +++++++++++++++++++
 libs/Android.mk              |    1 +
 libs/asio/Android.mk         |    7 +++
 libs/asio/example/Android.mk |   83 ++++++++++++++++++++++++++++
 libs/asio/libboost-asio.mk   |   59 ++++++++++++++++++++
 libs/asio/test/Android.mk    |  123 ++++++++++++++++++++++++++++++++++++++++++
 libs/regex/Android.mk        |   55 +++++++++++++++++++
 libs/system/Android.mk       |   45 ++++++++++++++++
 libs/test/Android.mk         |   57 ++++++++++++++++++++
 10 files changed, 485 insertions(+)
 create mode 100644 Android.mk
 create mode 100644 android/Android.mk
 create mode 100644 libs/Android.mk
 create mode 100644 libs/asio/Android.mk
 create mode 100644 libs/asio/example/Android.mk
 create mode 100644 libs/asio/libboost-asio.mk
 create mode 100644 libs/asio/test/Android.mk
 create mode 100644 libs/regex/Android.mk
 create mode 100644 libs/system/Android.mk
 create mode 100644 libs/test/Android.mk

diff --git a/Android.mk b/Android.mk
new file mode 100644
index 000000000000..65711611ccc6
--- /dev/null
+++ b/Android.mk
@@ -0,0 +1 @@
+include $(all-subdir-makefiles)
diff --git a/android/Android.mk b/android/Android.mk
new file mode 100644
index 000000000000..fda1b526d5e5
--- /dev/null
+++ b/android/Android.mk
@@ -0,0 +1,54 @@
+# Distributed under the Boost Software License, Version 1.0.
+#    (See accompanying file LICENSE_1_0.txt or copy at
+#          http://www.boost.org/LICENSE_1_0.txt)
+#
+# Copyright 2014 Intel Corporation
+
+LOCAL_PATH := $(call my-dir)
+
+libboost_rootdir := $(LOCAL_PATH)/..
+
+libboost_all_modules := \
+	$(libboost_rootdir)/libs/array/include \
+	$(libboost_rootdir)/libs/asio/include \
+	$(libboost_rootdir)/libs/assert/include \
+	$(libboost_rootdir)/libs/bind/include \
+	$(libboost_rootdir)/libs/concept_check/include \
+	$(libboost_rootdir)/libs/config/include \
+	$(libboost_rootdir)/libs/container/include \
+	$(libboost_rootdir)/libs/core/include \
+	$(libboost_rootdir)/libs/date_time/include \
+	$(libboost_rootdir)/libs/detail/include \
+	$(libboost_rootdir)/libs/exception/include \
+	$(libboost_rootdir)/libs/functional/include \
+	$(libboost_rootdir)/libs/integer/include \
+	$(libboost_rootdir)/libs/io/include \
+	$(libboost_rootdir)/libs/iterator/include \
+	$(libboost_rootdir)/libs/lexical_cast/include \
+	$(libboost_rootdir)/libs/math/include \
+	$(libboost_rootdir)/libs/move/include \
+	$(libboost_rootdir)/libs/mpl/include \
+	$(libboost_rootdir)/libs/numeric/conversion/include \
+	$(libboost_rootdir)/libs/optional/include \
+	$(libboost_rootdir)/libs/predef/include \
+	$(libboost_rootdir)/libs/preprocessor/include \
+	$(libboost_rootdir)/libs/range/include \
+	$(libboost_rootdir)/libs/regex/include \
+	$(libboost_rootdir)/libs/smart_ptr/include \
+	$(libboost_rootdir)/libs/static_assert/include \
+	$(libboost_rootdir)/libs/system/include \
+	$(libboost_rootdir)/libs/test/include \
+	$(libboost_rootdir)/libs/throw_exception/include \
+	$(libboost_rootdir)/libs/timer/include \
+	$(libboost_rootdir)/libs/type_traits/include \
+	$(libboost_rootdir)/libs/utility/include \
+
+include $(CLEAR_VARS)
+LOCAL_MODULE := libboost
+LOCAL_EXPORT_C_INCLUDE_DIRS := $(libboost_all_modules)
+include $(BUILD_STATIC_LIBRARY)
+
+include $(CLEAR_VARS)
+LOCAL_MODULE := libboost
+LOCAL_EXPORT_C_INCLUDE_DIRS := $(libboost_all_modules)
+include $(BUILD_HOST_STATIC_LIBRARY)
diff --git a/libs/Android.mk b/libs/Android.mk
new file mode 100644
index 000000000000..65711611ccc6
--- /dev/null
+++ b/libs/Android.mk
@@ -0,0 +1 @@
+include $(all-subdir-makefiles)
diff --git a/libs/asio/Android.mk b/libs/asio/Android.mk
new file mode 100644
index 000000000000..50f3dfda6071
--- /dev/null
+++ b/libs/asio/Android.mk
@@ -0,0 +1,7 @@
+LOCAL_PATH := $(call my-dir)
+
+backup_local_path := $(LOCAL_PATH)
+
+include $(backup_local_path)/libboost-asio.mk
+include $(backup_local_path)/test/Android.mk
+include $(backup_local_path)/example/Android.mk
diff --git a/libs/asio/example/Android.mk b/libs/asio/example/Android.mk
new file mode 100644
index 000000000000..3deceaf06074
--- /dev/null
+++ b/libs/asio/example/Android.mk
@@ -0,0 +1,83 @@
+# Distributed under the Boost Software License, Version 1.0.
+#    (See accompanying file LICENSE_1_0.txt or copy at
+#          http://www.boost.org/LICENSE_1_0.txt)
+#
+# Copyright 2014 Intel Corporation
+
+LOCAL_PATH := $(call my-dir)
+
+# chat client/server
+
+include $(CLEAR_VARS)
+LOCAL_MODULE := asio-example-chat-server
+
+LOCAL_SRC_FILES := cpp11/chat/chat_server.cpp
+LOCAL_STATIC_LIBRARIES := libboost libboost-system
+LOCAL_CFLAGS := -std=c++11 -frtti -fexceptions
+
+# Due to a bug in Android's clang support for thread-local-storage, use GCC as
+# compiler. However, we are still using clang's stl and we need to explicitly
+# link with libgcc.
+# LOCAL_CLANG := true
+LOCAL_LDFLAGS := -lgcc
+
+LOCAL_MODULE_TAGS := optional
+
+include external/libcxx/libcxx.mk
+include $(BUILD_EXECUTABLE)
+
+include $(CLEAR_VARS)
+LOCAL_MODULE := asio-example-chat-client
+
+LOCAL_SRC_FILES := cpp11/chat/chat_client.cpp
+LOCAL_STATIC_LIBRARIES := libboost libboost-system
+LOCAL_CFLAGS := -std=c++11 -frtti -fexceptions \
+
+# Due to a bug in Android's clang support for thread-local-storage, use GCC as
+# compiler. However, we are still using clang's stl and we need to explicitly
+# link with libgcc.
+# LOCAL_CLANG := true
+LOCAL_LDFLAGS := -lgcc
+
+LOCAL_MODULE_TAGS := optional
+
+include external/libcxx/libcxx.mk
+include $(BUILD_EXECUTABLE)
+
+include $(CLEAR_VARS)
+LOCAL_MODULE := asio-example-echo-server
+
+LOCAL_SRC_FILES := cpp11/echo/async_tcp_echo_server.cpp
+
+LOCAL_STATIC_LIBRARIES := libboost libboost-system
+LOCAL_CFLAGS := -std=c++11 -frtti -fexceptions
+
+# Due to a bug in Android's clang support for thread-local-storage, use GCC as
+# compiler. However, we are still using clang's stl and we need to explicitly
+# link with libgcc.
+# LOCAL_CLANG := true
+LOCAL_LDFLAGS := -lgcc
+
+LOCAL_MODULE_TAGS := optional
+
+include external/libcxx/libcxx.mk
+include $(BUILD_EXECUTABLE)
+
+include $(CLEAR_VARS)
+LOCAL_MODULE := asio-example-echo-client
+
+LOCAL_SRC_FILES := cpp11/echo/blocking_tcp_echo_client.cpp
+
+LOCAL_STATIC_LIBRARIES := libboost libboost-system
+LOCAL_CFLAGS := -std=c++11 -frtti -fexceptions
+
+# Due to a bug in Android's clang support for thread-local-storage, use GCC as
+# compiler. However, we are still using clang's stl and we need to explicitly
+# link with libgcc.
+# LOCAL_CLANG := true
+LOCAL_LDFLAGS := -lgcc
+
+LOCAL_MODULE_TAGS := optional
+
+include external/libcxx/libcxx.mk
+include $(BUILD_EXECUTABLE)
diff --git a/libs/asio/libboost-asio.mk b/libs/asio/libboost-asio.mk
new file mode 100644
index 000000000000..8bc1001c74c8
--- /dev/null
+++ b/libs/asio/libboost-asio.mk
@@ -0,0 +1,59 @@
+# Distributed under the Boost Software License, Version 1.0.
+#    (See accompanying file LICENSE_1_0.txt or copy at
+#          http://www.boost.org/LICENSE_1_0.txt)
+#
+# Copyright 2014 Intel Corporation
+
+LOCAL_PATH := $(call my-dir)
+
+# target
+# You may either a) link against this library or b) simply use its headers
+# if a) You must define BOOST_ASIO_SEPARATE_COMPILATION in your CFLAGS;
+# if b) You may fetch the headers by statically linking with "libboost" which
+#       is a "hack" target simply exporting all of boost libraries' include
+#       directories.
+# See http://www.boost.org/doc/libs/1_56_0/doc/html/boost_asio/using.html
+include $(CLEAR_VARS)
+LOCAL_MODULE := libboost-asio
+
+LOCAL_SRC_FILES := asio.cpp
+LOCAL_C_INCLUDES := $(LOCAL_PATH)/include
+LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)/include
+
+LOCAL_CFLAGS := \
+    -DBOOST_ASIO_DYN_LINK \
+    -std=c++11 -frtti -fexceptions
+
+LOCAL_STATIC_LIBRARIES := libboost libboost-system
+
+# Due to a bug in Android's clang support for thread-local-storage, use GCC as
+# compiler. However, we are still using clang's stl and we need to explicitly
+# link with libgcc.
+# LOCAL_CLANG := true
+LOCAL_LDFLAGS += -lgcc
+
+include external/libcxx/libcxx.mk
+include $(BUILD_SHARED_LIBRARY)
+
+# host
+# see comments to the "target" version
+include $(CLEAR_VARS)
+LOCAL_MODULE := libboost-asio
+
+LOCAL_SRC_FILES := asio.cpp
+LOCAL_C_INCLUDES := $(LOCAL_PATH)/include
+LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)/include
+
+LOCAL_CFLAGS := \
+    -DBOOST_ASIO_DYN_LINK \
+    -std=c++11 -frtti -fexceptions \
+    -pthread
+
+LOCAL_STATIC_LIBRARIES := libboost libboost-system
+
+LOCAL_LDFLAGS := -lpthread
+
+LOCAL_CLANG := true
+
+include external/libcxx/libcxx.mk
+include $(BUILD_HOST_SHARED_LIBRARY)
diff --git a/libs/asio/test/Android.mk b/libs/asio/test/Android.mk
new file mode 100644
index 000000000000..efcc5d818d9d
--- /dev/null
+++ b/libs/asio/test/Android.mk
@@ -0,0 +1,123 @@
+# Distributed under the Boost Software License, Version 1.0.
+#    (See accompanying file LICENSE_1_0.txt or copy at
+#          http://www.boost.org/LICENSE_1_0.txt)
+#
+# Copyright 2014 Intel Corporation
+
+LOCAL_PATH := $(call my-dir)
+
+define make-libboost-asio-test
+$( \
+    $(eval include $(CLEAR_VARS)) \
+    $(eval LOCAL_MODULE := libboost-asio-test-$(subst /,-,$(1))) \
+    $(eval LOCAL_SRC_FILES := $(1).cpp) \
+    $(eval LOCAL_C_INCLUDES := $(LOCAL_PATH)/../include) \
+    $(eval LOCAL_STATIC_LIBRARIES := libboost \
+        libboost-system \
+        libboost-test \
+        libboost-regex) \
+    $(eval LOCAL_CFLAGS := -UNDEBUG) \
+    $(eval LOCAL_CFLAGS += -std=c++11 -frtti -fexceptions -pthread) \
+    $(eval LOCAL_LDFLAGS := -lpthread) \
+    $(eval LOCAL_CLANG := true) \
+    $(eval LOCAL_MODULE_TAGS := tests) \
+    $(eval include external/libcxx/libcxx.mk) \
+    $(eval include $(BUILD_HOST_EXECUTABLE)) \
+    \
+    $(eval include $(CLEAR_VARS)) \
+    $(eval LOCAL_MODULE := libboost-asio-test-$(subst /,-,$(1))) \
+    $(eval LOCAL_SRC_FILES := $(1).cpp) \
+    $(eval LOCAL_C_INCLUDES := $(LOCAL_PATH)/../include) \
+    $(eval LOCAL_STATIC_LIBRARIES := libboost \
+        libboost-system \
+        libboost-test \
+        libboost-regex) \
+    $(eval LOCAL_CFLAGS := -UNDEBUG) \
+    $(eval LOCAL_CFLAGS += -std=c++11 -frtti -fexceptions) \
+    $(eval LOCAL_LDFLAGS := -lgcc) \
+    $(eval LOCAL_MODULE_TAGS := tests) \
+    $(eval include external/libcxx/libcxx.mk) \
+    $(eval include $(BUILD_EXECUTABLE))
+)
+endef
+
+$(call make-libboost-asio-test,basic_datagram_socket)
+$(call make-libboost-asio-test,basic_deadline_timer)
+$(call make-libboost-asio-test,basic_raw_socket)
+$(call make-libboost-asio-test,basic_seq_packet_socket)
+$(call make-libboost-asio-test,basic_serial_port)
+$(call make-libboost-asio-test,basic_signal_set)
+$(call make-libboost-asio-test,basic_socket_acceptor)
+$(call make-libboost-asio-test,basic_stream_socket)
+$(call make-libboost-asio-test,basic_streambuf)
+$(call make-libboost-asio-test,basic_waitable_timer)
+$(call make-libboost-asio-test,buffer)
+$(call make-libboost-asio-test,buffers_iterator)
+$(call make-libboost-asio-test,buffered_read_stream)
+$(call make-libboost-asio-test,buffered_stream)
+$(call make-libboost-asio-test,buffered_write_stream)
+$(call make-libboost-asio-test,completion_condition)
+$(call make-libboost-asio-test,connect)
+$(call make-libboost-asio-test,coroutine)
+$(call make-libboost-asio-test,datagram_socket_service)
+$(call make-libboost-asio-test,deadline_timer_service)
+$(call make-libboost-asio-test,deadline_timer)
+$(call make-libboost-asio-test,error)
+$(call make-libboost-asio-test,generic/basic_endpoint)
+$(call make-libboost-asio-test,generic/datagram_protocol)
+$(call make-libboost-asio-test,generic/raw_protocol)
+$(call make-libboost-asio-test,generic/seq_packet_protocol)
+$(call make-libboost-asio-test,generic/stream_protocol)
+$(call make-libboost-asio-test,high_resolution_timer)
+$(call make-libboost-asio-test,io_service)
+$(call make-libboost-asio-test,ip/address)
+$(call make-libboost-asio-test,ip/address_v4)
+$(call make-libboost-asio-test,ip/address_v6)
+$(call make-libboost-asio-test,ip/basic_endpoint)
+$(call make-libboost-asio-test,ip/basic_resolver)
+$(call make-libboost-asio-test,ip/basic_resolver_entry)
+$(call make-libboost-asio-test,ip/basic_resolver_iterator)
+$(call make-libboost-asio-test,ip/basic_resolver_query)
+$(call make-libboost-asio-test,ip/host_name)
+$(call make-libboost-asio-test,ip/icmp)
+$(call make-libboost-asio-test,ip/multicast)
+$(call make-libboost-asio-test,ip/resolver_query_base)
+$(call make-libboost-asio-test,ip/resolver_service)
+$(call make-libboost-asio-test,ip/tcp)
+$(call make-libboost-asio-test,ip/udp)
+$(call make-libboost-asio-test,ip/unicast)
+$(call make-libboost-asio-test,ip/v6_only)
+$(call make-libboost-asio-test,is_read_buffered)
+$(call make-libboost-asio-test,is_write_buffered)
+$(call make-libboost-asio-test,local/basic_endpoint)
+$(call make-libboost-asio-test,local/connect_pair)
+$(call make-libboost-asio-test,local/datagram_protocol)
+$(call make-libboost-asio-test,local/stream_protocol)
+$(call make-libboost-asio-test,placeholders)
+$(call make-libboost-asio-test,posix/basic_descriptor)
+$(call make-libboost-asio-test,posix/basic_stream_descriptor)
+$(call make-libboost-asio-test,posix/descriptor_base)
+$(call make-libboost-asio-test,posix/stream_descriptor)
+$(call make-libboost-asio-test,posix/stream_descriptor_service)
+$(call make-libboost-asio-test,raw_socket_service)
+$(call make-libboost-asio-test,read)
+$(call make-libboost-asio-test,read_at)
+$(call make-libboost-asio-test,read_until)
+$(call make-libboost-asio-test,seq_packet_socket_service)
+$(call make-libboost-asio-test,serial_port)
+$(call make-libboost-asio-test,serial_port_base)
+$(call make-libboost-asio-test,serial_port_service)
+$(call make-libboost-asio-test,signal_set)
+$(call make-libboost-asio-test,signal_set_service)
+$(call make-libboost-asio-test,socket_acceptor_service)
+$(call make-libboost-asio-test,socket_base)
+$(call make-libboost-asio-test,steady_timer)
+$(call make-libboost-asio-test,strand)
+$(call make-libboost-asio-test,stream_socket_service)
+$(call make-libboost-asio-test,streambuf)
+$(call make-libboost-asio-test,system_timer)
+$(call make-libboost-asio-test,time_traits)
+$(call make-libboost-asio-test,wait_traits)
+$(call make-libboost-asio-test,waitable_timer_service)
+$(call make-libboost-asio-test,write)
+$(call make-libboost-asio-test,write_at)
diff --git a/libs/regex/Android.mk b/libs/regex/Android.mk
new file mode 100644
index 000000000000..32bb0643c23e
--- /dev/null
+++ b/libs/regex/Android.mk
@@ -0,0 +1,55 @@
+# Distributed under the Boost Software License, Version 1.0.
+#    (See accompanying file LICENSE_1_0.txt or copy at
+#          http://www.boost.org/LICENSE_1_0.txt)
+#
+# Copyright 2014 Intel Corporation
+
+LOCAL_PATH := $(call my-dir)
+
+libboost-regex_src := \
+    src/c_regex_traits.cpp \
+    src/cpp_regex_traits.cpp \
+    src/cregex.cpp \
+    src/fileiter.cpp \
+    src/icu.cpp \
+    src/instances.cpp \
+    src/posix_api.cpp \
+    src/regex.cpp \
+    src/regex_debug.cpp \
+    src/regex_raw_buffer.cpp \
+    src/regex_traits_defaults.cpp \
+    src/static_mutex.cpp \
+    src/w32_regex_traits.cpp \
+    src/wc_regex_traits.cpp \
+    src/wide_posix_api.cpp \
+    src/winstances.cpp \
+    src/usinstances.cpp
+
+include $(CLEAR_VARS)
+
+LOCAL_MODULE := libboost-regex
+LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)/include
+
+LOCAL_STATIC_LIBRARIES := libboost
+
+LOCAL_C_INCLUDES := $(LOCAL_PATH)/include
+LOCAL_SRC_FILES := $(libboost-regex_src)
+
+TODO: do we want to define BOOST_HAS_ICU ?
+LOCAL_CLANG := true
+include external/libcxx/libcxx.mk
+include $(BUILD_STATIC_LIBRARY)
+
+include $(CLEAR_VARS)
+
+LOCAL_MODULE := libboost-regex
+LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)/include
+
+LOCAL_STATIC_LIBRARIES := libboost
+
+LOCAL_C_INCLUDES := $(LOCAL_PATH)/include
+LOCAL_SRC_FILES := $(libboost-regex_src)
+
+LOCAL_CLANG := true
+include external/libcxx/libcxx.mk
+include $(BUILD_HOST_STATIC_LIBRARY)
diff --git a/libs/system/Android.mk b/libs/system/Android.mk
new file mode 100644
index 000000000000..c145609a4f08
--- /dev/null
+++ b/libs/system/Android.mk
@@ -0,0 +1,45 @@
+# Distributed under the Boost Software License, Version 1.0.
+#    (See accompanying file LICENSE_1_0.txt or copy at
+#          http://www.boost.org/LICENSE_1_0.txt)
+#
+# Copyright 2014 Intel Corporation
+
+LOCAL_PATH := $(call my-dir)
+
+include $(CLEAR_VARS)
+
+LOCAL_MODULE := libboost-system
+LOCAL_MODULE_TAGS := optional
+LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)/include
+
+LOCAL_C_INCLUDES := $(LOCAL_PATH)/include
+LOCAL_SRC_FILES := src/error_code.cpp
+LOCAL_STATIC_LIBRARIES := libboost
+
+LOCAL_CLANG := true
+
+include external/libcxx/libcxx.mk
+include $(BUILD_STATIC_LIBRARY)
+
+include $(CLEAR_VARS)
+
+LOCAL_MODULE := libboost-system
+LOCAL_MODULE_TAGS := optional
+LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)/include
+
+LOCAL_C_INCLUDES := $(LOCAL_PATH)/include
+LOCAL_SRC_FILES := src/error_code.cpp
+LOCAL_STATIC_LIBRARIES := libboost
+
+LOCAL_CLANG := true
+
+include external/libcxx/libcxx.mk
+include $(BUILD_HOST_STATIC_LIBRARY)
+
+include $(CLEAR_VARS)
+LOCAL_MODULE := boost-system-error_code_test
+LOCAL_SRC_FILES := test/error_code_test.cpp
+LOCAL_STATIC_LIBRARIES := libboost-system libboost
+LOCAL_MODULE_TAGS := tests
+include external/libcxx/libcxx.mk
+include $(BUILD_EXECUTABLE)
diff --git a/libs/test/Android.mk b/libs/test/Android.mk
new file mode 100644
index 000000000000..06e1b7011235
--- /dev/null
+++ b/libs/test/Android.mk
@@ -0,0 +1,57 @@
+# Distributed under the Boost Software License, Version 1.0.
+#    (See accompanying file LICENSE_1_0.txt or copy at
+#          http://www.boost.org/LICENSE_1_0.txt)
+#
+# Copyright 2014 Intel Corporation
+
+LOCAL_PATH := $(call my-dir)
+
+libboost-test_src := \
+    src/compiler_log_formatter.cpp \
+    src/debug.cpp \
+    src/exception_safety.cpp \
+    src/execution_monitor.cpp \
+    src/framework.cpp \
+    src/interaction_based.cpp \
+    src/logged_expectations.cpp \
+    src/plain_report_formatter.cpp \
+    src/progress_monitor.cpp \
+    src/results_collector.cpp \
+    src/results_reporter.cpp \
+    src/test_tools.cpp \
+    src/unit_test_log.cpp \
+    src/unit_test_main.cpp \
+    src/unit_test_monitor.cpp \
+    src/unit_test_parameters.cpp \
+    src/unit_test_suite.cpp \
+    src/xml_log_formatter.cpp \
+    src/xml_report_formatter.cpp \
+
+include $(CLEAR_VARS)
+
+LOCAL_MODULE := libboost-test
+
+LOCAL_STATIC_LIBRARIES := libboost
+
+LOCAL_C_INCLUDES := $(LOCAL_PATH)/include
+LOCAL_SRC_FILES := $(libboost-test_src)
+
+LOCAL_CLANG := true
+include external/libcxx/libcxx.mk
+LOCAL_CFLAGS += -frtti -fexceptions
+include $(BUILD_STATIC_LIBRARY)
+
+include $(CLEAR_VARS)
+
+LOCAL_MODULE := libboost-test
+LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)/include
+
+LOCAL_STATIC_LIBRARIES := libboost
+
+LOCAL_C_INCLUDES := $(LOCAL_PATH)/include
+LOCAL_SRC_FILES := $(libboost-test_src)
+
+LOCAL_CLANG := true
+include external/libcxx/libcxx.mk
+LOCAL_CFLAGS += -frtti -fexceptions
+include $(BUILD_HOST_STATIC_LIBRARY)
-- 
1.7.9.5